package com.dust.tripartite.netmc;

import com.dust.tripartite.netmc.codec.MyMessageDecoder;
import com.dust.tripartite.netmc.codec.MyMessageEncoder;
import com.dust.tripartite.netmc.core.DefaultHandlerMapping;
import com.dust.tripartite.netmc.endpoint.MyHandlerInterceptor;
import com.dust.tripartite.netmc.session.SessionManager;

import java.nio.charset.StandardCharsets;

public class QuickStart {

    public static void main(String[] args) {
        NettyConfig jtConfig = new NettyConfig.Builder()
                .setPort(8080)
                .setMaxFrameLength(1024)
                .setDelimiters(new byte[][]{"|".getBytes(StandardCharsets.UTF_8)})
                .setDecoder(new MyMessageDecoder())
                .setEncoder(new MyMessageEncoder())
                .setHandlerMapping(new DefaultHandlerMapping("io.github.yezhihao.netmc.endpoint"))
//                .setHandlerMapping(new SpringHandlerMapping("org.yzh.web.endpoint"))
                .setHandlerInterceptor(new MyHandlerInterceptor())
                .setSessionManager(new SessionManager())
                .build();

        TCPServer tcpServer = new TCPServer("Test服务", jtConfig);
        tcpServer.start();
    }
}